/*
 * ******************************************************************************************
 *
 * File		: apb_spi_hal.c
 * Author	: GOWIN
 * Function	: Hardware platform level definition of APB SPI
 *
 * ******************************************************************************************
 */

// Includes ---------------------------------------------------------------------------------
#include "apb_spi_hal.h"


// Definitions  -----------------------------------------------------------------------------

/************************* DMA **********************************/
// Should be re-defined by user based on different platform.


/************************ INTERRUPT *****************************/
// Should be re-defined by user based on different platform.

// Disable interrupt
void hal_disable_interrupt(unsigned int source)
{
	// User customized code
	//...

	__nds__plic_disable_interrupt(source);
}

// Enable interrupt
void hal_enable_interrupt(unsigned int source)
{
	// User customized code
	//...

	// Priority must be set > 0 to trigger the interrupt
	__nds__plic_set_priority(source, 1);

	// Enable PLIC interrupt PIT source
	__nds__plic_enable_interrupt(source);

	// Enable the Machine-External bit in MIE
	set_csr(NDS_MIE, MIP_MEIP);

	// Enable GIE
	set_csr(NDS_MSTATUS, MSTATUS_MIE);
}
